//LOOK AT MY DUMBASS MAKING CODE WEEEEEEEEEEEEEEEEEEEEE

local supertimer = 50
CV_RegisterVar({name="ZT_SUPERTIMER",defaultvalue="50",
	flags=CV_CALL|CV_NETVAR|CV_NOINIT|CV_SHOWMODIF,
	PossibleValue={MIN = 0, MAX = 300},
	func=function(cv)
		supertimer=cv.value
	end
})

local allowsuper = 0
CV_RegisterVar({name="ZT_ALLOWSUPER",defaultvalue="Off",
	flags=CV_CALL|CV_NETVAR|CV_NOINIT|CV_SHOWMODIF,
	PossibleValue={Off=0,On=1},
	func=function(cv)
		allowsuper=cv.value
	end
})

local supertag = 0
CV_RegisterVar({name="ZT_SUPERTAG",defaultvalue="Off",
	flags=CV_CALL|CV_NETVAR|CV_NOINIT|CV_SHOWMODIF,
	PossibleValue={Off=0,On=1},
	func=function(cv)
		supertag=cv.value
	end
})

//Admin tools(by OtherChen) rings command for Supertag.
COM_AddCommand("rings", function(player, amount)
	if not amount then
		CONS_Printf(player, "rings <amount>: give yourself rings")
		return
	end
	
		local N = tonumber(amount)
		if N ~= nil then
			P_GivePlayerRings(player, -9999)
			P_GivePlayerRings(player, N)
		end
end)

//literally just Set Emeralds by flarn2006
COM_AddCommand('setemeralds', function(player, arg, arg2)
	if arg == nil or arg2 ~= nil then
		CONS_Printf(player, 'Usage:')
		CONS_Printf(player, 'setemeralds 0    - Remove all emeralds')
		CONS_Printf(player, 'setemeralds all  - Get all emeralds')
		CONS_Printf(player, 'setemeralds 124  - Get emeralds 1, 2, and 4; remove all others')
		CONS_Printf(player, '(Use the same method for any combination of emeralds.)')
	else
		if arg == 'all' then arg = '1234567' end
		local previous = emeralds
		emeralds = 0
		local bit = 1
		for i=1,7 do
			if string.find(arg, tostring(i)) ~= nil then
				emeralds = $ | bit
			end
			bit = $ * 2
		end
		print('Have fun using super forms.')
	end
end, COM_ADMIN)



addHook("MapLoad", do
  if G_TagGametype() then
      if allowsuper == 1 then
      COM_BufInsertText(player, "setemeralds all")
	end
		if supertag == 1 then
		COM_BufInsertText(player, "rings 300")
		COM_BufInsertText(player, "allowsuper 1")
		COM_BufInsertText(player, "supertimer 300")
		COM_BufInsertText(player, "setemeralds all")
		CONS_Printf(player, "Good luck catching people. Everyone has forms!!!")
	end
  end
end)

COM_AddCommand('ZT_HELP', function(player)
	CONS_Printf(player, 'ZT_HELP       - Shows this text.')
	CONS_Printf(player, 'ZT_ALLOWSUPER - Self explanatory.')
	CONS_Printf(player, 'ZT_SUPERTIMER - Set time allowed to be super. Default is 50 seconds. 0 to 300')
	CONS_Printf(player, 'ZT_SUPERTAG   - Sets rings to 300 at the start of the match.')
	CONS_Printf(player, 'ZT_RADAR      - Toggle Radar On/Off')
end)


//Restrict Super time
//Code borrowed from Zoraxua's Super in Ringslinger
addHook("PlayerThink", function(player)
	if gametype == GT_ZOMBIETAG
	//Local variables to help the game
		if player.iwantemmymusic == nil then player.iwantemmymusic = 0 end
		if player.myemmymusicis == nil then player.myemmymusicis = "_INV" end
	//Poggers

		//Now what's the requirements?
		if player.powers[pw_super] //Don't wanna remove super mid-use
			if player.powers[pw_super] == supertimer*TICRATE
				player.powers[pw_super] = 0 //So lose super if you've had it for too long, grr
				player.rings = 0
				//Following ripped from SR lmao
				S_StartSound(nil, sfx_s3k9c) //Trans SFX, global so everyone knows!
				player.mo.color = player.skincolor //Fix supercolor
				player.mo.state = player.mo.state //Go back to normal if you have super sprites
				P_SpawnShieldOrb(player) //Get the sheild back if you had one
				P_RestoreMusic(player) //Fix music if character uses custom for soup
			end
		end
	end
end)

local function isInGamemode()
	return gametype == GT_ZOMBIETAG
end


//L_FreezeTag_v4.lua code cause I'm not writing a radar code :)
//https://mb.srb2.org/addons/freeze-tag.3179/
//

local gametime=(5*60*TICRATE) --How long rounds last.

local radarwarn=0

local radar=1
CV_RegisterVar({name="ZT_RADAR",defaultvalue="On",
	flags=CV_CALL|CV_NOINIT|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue={Off=0,On=1},
	func=function(cv)
		radar=cv.value
	end
})


local radarscale=(45*FRACUNIT)

local timeclose = 30*TICRATE


--[[Gamemode Constants]]
local color_it = 35
local color_runner = 150	
local function isPlayerActive(pl)
	return pl.mo and not pl.spectator
end
local function isIt(pl)
	return pl.pflags & PF_TAGIT
end
local function countPlayers()
	local count,it=0,0,0
	for pl in players.iterate
		if pl.spectator then continue end
		
		if isIt(pl) then it=$+1 end
		count=count+1
	end
	return count,it
end
local function isInGamemode()
	return gametype == GT_ZOMBIETAG
end

--[[HUD]]
local function drawHeader(g,pl)
	
	--[[Timer]]
	if not isInGamemode () then return end
		local color
		g.drawString(160,0, "Time:", color or V_YELLOWMAP, "center")
		g.drawString(160,8, tostring((gametime-leveltime)/TICRATE), color, "center")
end

local function drawTooltips(g,pl)
	local i=0
	
	for k,v in pairs(tooltips["general"]) do
		drawTooltip(g,pl,i,v)
		i=i+1
	end

	local state = "idle"
	if leveltime > 0 then
		if isIt(pl) then
			state = "it"
		end
		if not isIt(pl) then
			state = "runner"
		end
		
	end
	for k,v in pairs(tooltips[state]) do
		drawTooltip(g,pl,i,v)
		i=i+1
	end
end

hud.add(function(g,pl,cam)
	if not isInGamemode() then return end
	if pl.playerstate == PST_LIVE then
		
		local yo=0
		if not radar then yo=64 end
		--[[Status]]
		local str="RUNNER!"
		local c=V_BLUEMAP
		if isIt(pl) then
			str="ZOMBIE!" c=V_GREENMAP
		end

		if allowsuper == 1
		g.drawString(8,112+yo, str, c)
		else
		g.drawString(8,120+yo, str, c)
		end
		
	  		--[[Rings]]	
		if allowsuper then
			local c=V_WHITEMAP
			
			if pl.rings >= supertimer and not pl.powers[pw_super] then c=V_YELLOWMAP end
			
			if pl.isxmomentum and pl.rings >=150 then c=V_SKYMAP end
			
					if not pl.powers[pw_super]
						g.drawString(8,120+yo, "RINGS: "+tostring(pl.rings), c)
					elseif pl.isxmomentum and pl.hyper.capable and pl.powers[pw_super]
						g.drawString(8,120+yo, "HYPER: "+tostring((((supertimer*TICRATE) - pl.powers[pw_super])/TICRATE)+1), c)
					else
						g.drawString(8,120+yo, "SUPER: "+tostring((((supertimer*TICRATE) - pl.powers[pw_super])/TICRATE)+1), c)
					end
		end
		
		--[[Radar]]
		if radar then
			local angle = (-cam.angle)-ANGLE_90
			local offsetx = 8
			local offsety = 128

			local framecolor = 3
		
			for pl2 in players.iterate do
				if pl2.playerstate ~= PST_LIVE or not isPlayerActive(pl2) then continue end
				local ox,oy = pl2.mo.x - pl.mo.x, pl2.mo.y - pl.mo.y
				local x = -(FixedMul(ox,cos(angle))-FixedMul(oy,sin(angle)))/radarscale
				local y =  (FixedMul(ox,sin(angle))+FixedMul(oy,cos(angle)))/radarscale
				
				--Phase out surviving teammate runners or teammate taggers as unimportant information.
				if (x > 31) or (x < -31) or (y > 31) or (y < -31) then
					if not isIt(pl)
					and not isIt(pl2)
						continue
					end
					if isIt(pl) and isIt(pl2) then
						continue
					end
				end
				x = max(x,-31)
				x = min(x,31)
				y = max(y,-31)
				y = min(y,31)

				local blink = leveltime % 4 == 0
				local color = color_unassigned
				if not isIt(pl2) and leveltime > 0 then
					color = color_runner
		
					if isIt(pl) then
						framecolor = color_runner
					end
				end
				if isIt(pl2) then
					color = color_it
					if not isIt(pl) then
						if blink then
							color = color_itblink
						end
						framecolor = color_it
					end
				end
				g.drawFill(offsetx+30+x,offsety+30+y,4,4,color)
			end
		
			if not radarwarn then framecolor = 3 end
			
			g.drawFill(offsetx, offsety,	64,1,framecolor)
			g.drawFill(offsetx, offsety+63,	64,1,framecolor)
			g.drawFill(offsetx, offsety,	1,64,framecolor)
			g.drawFill(offsetx+63, offsety,	1,64,framecolor)
		end

		drawHeader(g,pl)
       	if guide == 1 then 
			drawTooltips(g,pl)
		end
		if guide == 2 then
			drawWelcome(g,pl)
		end
	end
end, "game")

addHook("MapLoad", function()
	if isInGamemode() then
		hud.disable("weaponrings")
		hud.disable("score")
		hud.disable("rings")
		hud.disable("time")
		hud.disable("lives")
	else
		hud.enable("weaponrings")
		hud.enable("score")
		hud.enable("rings")
		hud.enable("time")
		hud.enable("lives")
	end
end)